<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small" v-show="showSearch" label-width="68px">
      <el-form-item label="党员姓名" prop="nickName">
        <el-input
          v-model="queryParams.nickName"
          placeholder="请输入党员姓名"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="考核时间" prop="assessTime">
        <el-date-picker clearable size="small" style="width: 200px"
          v-model="queryParams.assessTime"
          type="date"
          value-format="yyyy-MM-dd"
          placeholder="选择考核时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="归属部门" prop="deptId" style="width: 268px;">
        <treeselect style="width: 200px;" v-model="queryParams.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['branch:assess:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['branch:assess:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['branch:assess:remove']"
        >删除</el-button>
      </el-col>
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="info"-->
          <!--plain-->
          <!--icon="el-icon-upload2"-->
          <!--size="mini"-->
          <!--@click="handleImport"-->
          <!--v-hasPermi="['branch:assess:edit']"-->
        <!--&gt;导入</el-button>-->
      <!--</el-col>-->
      <!--<el-col :span="1.5">-->
        <!--<el-button-->
          <!--type="warning"-->
          <!--plain-->
          <!--icon="el-icon-download"-->
          <!--size="mini"-->
          <!--@click="handleExport"-->
          <!--v-hasPermi="['branch:assess:export']"-->
        <!--&gt;导出</el-button>-->
      <!--</el-col>-->
	  <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="assessList" @selection-change="handleSelectionChange" :height="clientHeight" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="所在支部" align="center" prop="deptId" width="120" :formatter="deptListFormat" />
      <el-table-column label="党员姓名" align="center" prop="assessMember" width="120" :formatter="userListFormat" />
      <el-table-column label="考核时间" align="center" prop="assessTime" width="100">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.assessTime, '{y}-{m}-{d}') }}</span>
        </template>
      </el-table-column>
      <el-table-column label="考核分数" align="center" prop="assessScore" />
      <el-table-column label="附件" align="center" prop="filesId" width="100">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-folder"
            @click="openFileDialog(scope.row)"
          >查看附件
          </el-button>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" fixed="right" width="120" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['branch:assess:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['branch:assess:remove']"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改纪律考评对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="党员" prop="assessMember">
          <el-select v-model="form.assessMember" placeholder="请选择党员">
            <el-option
              v-for="dict in userList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="考核时间" prop="assessTime">
          <el-date-picker clearable size="small" style="width: 200px"
            v-model="form.assessTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择考核时间">
          </el-date-picker>
        </el-form-item>
        <el-form-item label="考核分数" prop="assessScore">
          <el-input v-model="form.assessScore" placeholder="请输入考核分数" />
        </el-form-item>
          <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
          </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 用户导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
        <el-upload
                ref="upload"
                :limit="1"
                accept=".xlsx, .xls"
                :headers="upload.headers"
                :action="upload.url + '?updateSupport=' + upload.updateSupport"
                :disabled="upload.isUploading"
                :on-progress="handleFileUploadProgress"
                :on-success="handleFileSuccess"
                :auto-upload="false"
                drag
        >
            <i class="el-icon-upload"></i>
            <div class="el-upload__text">
                将文件拖到此处，或
                <em>点击上传</em>
            </div>
            <div class="el-upload__tip" slot="tip">
                <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据
                <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>
            </div>
            <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>
        </el-upload>
        <div slot="footer" class="dialog-footer">
            <el-button type="primary" @click="submitFileForm">确 定</el-button>
            <el-button @click="upload.open = false">取 消</el-button>
        </div>
    </el-dialog>
    <!-- 附件详情对话框 -->
    <el-dialog title="附件详情" :visible.sync="file.open" width="60%" append-to-body>
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-upload
            ref="doc"
            :headers="doc.headers"
            :action="doc.url+'?tableName=branchAssess&tableId=' + doc.tableId"
            :disabled="doc.isUploading"
            :on-progress="handleFileDocProgress"
            :on-success="handleFileDocSuccess"
            :auto-upload="true"
            :file-list="file.fileList"
          >
            <el-button type="primary"><i class="el-icon-upload"></i> 点击上传</el-button>
          </el-upload>
        </el-col>
      </el-row>
      <el-table :data="file.dataList">
        <el-table-column label="附件名称" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-document"
              @click="handleSee(scope.row.url)">
              {{ scope.row.name }}
            </el-button>
          </template>
        </el-table-column>
        <el-table-column label="上传人" align="center" prop="creater"/>
        <el-table-column label="上传时间" align="center" prop="createdate">
          <template slot-scope="scope">
            <span>{{ parseTime(scope.row.createdate, '{y}-{m}-{d}') }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center">
          <template slot-scope="scope">
            <el-button
              size="mini"
              type="text"
              icon="el-icon-delete"
              @click="handleDeleteFile(scope.row.id)"
            >删除
            </el-button>
          </template>
        </el-table-column>
      </el-table>
    </el-dialog>
  </div>
</template>

<script>
import { listAssess, getAssess, delAssess, addAssess, updateAssess, exportAssess, importTemplate} from "@/api/branch/assess";
import { treeselect } from "@/api/system/dept";
import { getToken } from "@/utils/auth";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import { listDept } from "@/api/system/dept";
import { listUserNoPage } from "@/api/system/user";
import {delFile, listFile} from "../../../../api/branch/file";

export default {
  name: "Assess",
  components: { Treeselect },
  data() {
    return {
      file: {
        id: null,
        open: false,
        fileList: [],
        dataList: [],
      },
      doc: {
        file: "",
        // 是否显示弹出层（报告附件）
        open: false,
        // 弹出层标题（报告附件）
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 设置上传的请求头部
        headers: {Authorization: "Bearer " + getToken()},
        tableId: 0,
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/branch/file/uploadFile",
      },
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 总条数
      total: 0,
      // 纪律考评表格数据
      assessList: [],
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      clientHeight:300,
      // 是否显示弹出层
      open: false,
        // 用户导入参数
        upload: {
            // 是否显示弹出层（用户导入）
            open: false,
            // 弹出层标题（用户导入）
            title: "",
            // 是否禁用上传
            isUploading: false,
            // 是否更新已经存在的用户数据
            updateSupport: 0,
            // 设置上传的请求头部
            headers: { Authorization: "Bearer " + getToken() },
            // 上传的地址
            url: process.env.VUE_APP_BASE_API + "/branch/assess/importData"
        },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        assessId: null,
        assessMember: null,
        assessTime: null,
        assessScore: null,
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        assessMember: [
          { required: true, message: "党员姓名不能为空", trigger: "blur" }
        ],
        assessTime: [
          { required: true, message: "考核时间不能为空", trigger: "blur" }
        ],
        assessScore: [
          { required: true, message: "考核分数不能为空", trigger: "blur" },
          { pattern: /^-?\d+\.?\d*$/, message: '分数不能为非数值', trigger: 'blur' }
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" }
        ],
      },
      // 用户列表
      userList: [],
      // 部门列表
      deptList: [],
    };
  },
  watch: {
        // 根据名称筛选部门树
        deptName(val) {
            this.$refs.tree.filter(val);
        }
   },
  created() {
    this.getUserList();
    this.getDeptList();
      //设置表格高度对应屏幕高度
      this.$nextTick(() => {
          this.clientHeight = document.body.clientHeight -250
      })
    this.getList();
    this.getTreeselect();
  },
  methods: {
    //附件上传中处理
    handleFileDocProgress(event, file, fileList) {
      this.doc.file = file;
    },
    //附件上传成功处理
    handleFileDocSuccess(response, file, fileList) {
      console.log(response.data, '-----', this.file.id);
      this.$modal.msgSuccess("上传成功");
      this.getFileList();
    },
    handleSee(url) {
      window.open(process.env.VUE_APP_BASE_API + url);
    },
    openFileDialog(row) {
      console.log(row)
      this.file.open = true;
      this.doc.tableId = row.assessId;
      this.getFileList();
    },
    getFileList() {
      listFile({tableId: this.doc.tableId, tableName: 'branchAssess'}).then(res => {
        this.file.dataList = res.data
      })
    },
    handleDeleteFile(id) {
      this.$confirm('是否确认删除?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delFile(id);
      }).then(() => {
        this.getFileList();
        this.msgSuccess("删除成功");
      })
    },
    /** 查询用户列表 */
    getUserList() {
      listUserNoPage().then(response => {
        let rows = response.data;
        let userList = [];
        for(let i = 0; i < rows.length; i++) {
          if (rows[i].userName != "admin") {
            let user = { "dictValue" : rows[i].userId, "dictLabel" : rows[i].nickName};
            userList.push(user);
          }
        }
        this.userList = userList;
      });
    },
    /** 查询部门列表 */
    getDeptList() {
      listDept().then(response => {
        let data = response.data;
        let deptList = [];
        for(let i = 0; i < data.length; i++) {
          let dept = { "dictValue" : data[i].deptId, "dictLabel" : data[i].deptName};
          deptList.push(dept);
        }
        this.deptList = deptList;
      });
    },
    // 用户列表字典翻译
    userListFormat(row, column) {
      return this.selectDictLabel(this.userList, row.assessMember);
    },
    // 部门列表字典翻译
    deptListFormat(row, column) {
      return this.selectDictLabel(this.deptList, row.deptId);
    },
    /** 查询纪律考评列表 */
    getList() {
      this.loading = true;
      listAssess(this.queryParams).then(response => {
        this.assessList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
     /** 查询部门下拉树结构 */
     getTreeselect() {
          treeselect().then(response => {
              this.deptOptions = response.data;
          });
     },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        assessId: null,
        assessMember: null,
        assessTime: null,
        assessScore: null,
        deptId: null,
        delFlag: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.assessId)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加纪律考评";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const assessId = row.assessId || this.ids
      getAssess(assessId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改纪律考评";
      });
    },
      /** 提交按钮 */
      submitForm() {
          this.$refs["form"].validate(valid => {
              if (valid) {
                  if (this.form.assessId != null) {
                      updateAssess(this.form).then(response => {
                          this.$modal.msgSuccess("修改成功");
                          this.open = false;
                          this.getList();
                      });
                  } else {
                      addAssess(this.form).then(response => {
                          this.$modal.msgSuccess("新增成功");
                          this.open = false;
                          this.getList();
                      });
                  }
              }
          });
      },
    /** 删除按钮操作 */
    handleDelete(row) {
      const assessIds = row.assessId || this.ids;
      this.$confirm('是否确认删除?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delAssess(assessIds);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有纪律考评数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return exportAssess(queryParams);
        }).then(response => {
          this.download(response.msg);
        })
    },
      /** 导入按钮操作 */
      handleImport() {
          this.upload.title = "用户导入";
          this.upload.open = true;
      },
      /** 下载模板操作 */
      importTemplate() {
          importTemplate().then(response => {
              this.download(response.msg);
          });
      },
      // 文件上传中处理
      handleFileUploadProgress(event, file, fileList) {
          this.upload.isUploading = true;
      },
      // 文件上传成功处理
      handleFileSuccess(response, file, fileList) {
          this.upload.open = false;
          this.upload.isUploading = false;
          this.$refs.upload.clearFiles();
          this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
          this.getList();
      },
      // 提交上传文件
      submitFileForm() {
          this.$refs.upload.submit();
      }
  }
};
</script>

<style>
    /** 文本换行符处理 */
    .el-table .cell{
        white-space: pre-wrap;
    }
    /** textarea字体 */
    textarea {
        font-family: "Helvetica Neue",Helvetica,"PingFang SC","Hiragino Sans GB","Microsoft YaHei","微软雅黑",Arial,sans-serif;
    }
</style>
